
import upygame as upg

class InputManager:

    def __init__(self):
        self.previous_frame_input_key = None
        self.previous_frame_key_event = None
        self.current_frame_input_key = None
        self.current_frame_key_event = None

    def check_key_input(self):
        self.previous_frame_input_key = self.current_frame_input_key
        self.previous_frame_key_event = self.current_frame_key_event
        
        eventtype = upg.event.poll()
        if eventtype == upg.NOEVENT:
            self.current_frame_input_key = None
            self.current_frame_key_event = None
        else:
            self.current_frame_input_key = eventtype.key
            self.current_frame_key_event = eventtype.type

    def first_pressed_key_in_current_frame(self):
        if self.current_frame_input_key == None or self.current_frame_key_event == None:
            return None
        if self.previous_frame_input_key != None:
            return None
        if self.current_frame_key_event == upg.KEYDOWN:
            return self.current_frame_input_key
        return None