
from abstract_scene import AbstractScene
from frame_manager import FrameManager
from input_manager import InputManager
import upygame as upg

class SceneTitle(AbstractScene):

    def __init__(self, my_game, input_manager, frame_manager):
        # for Intellisense support
        # assert isinstance(my_game, MyGame)
        # assert isinstance(input_manager, InputManager)
        # assert isinstance(frame_manager, FrameManager)
        
        self.my_game = my_game
        self.input_manager = input_manager
        self.frame_manager = frame_manager
        self.text_color = 3
        self.is_enabled_key_input = True
        self.key_pressed_frame = 0

    def execute(self):
        from main import MAX_FPS, SCENE_GAME, SCREEN_HEIGHT, SCREEN_WIDTH

        if self.is_enabled_key_input and self.input_manager.first_pressed_key_in_current_frame() != None:
            self.is_enabled_key_input = False
            self.text_color = 7
            self.key_pressed_frame = self.frame_manager.total_frame
        
        upg.draw.rect(upg.Rect(0, 0, SCREEN_WIDTH, SCREEN_HEIGHT), True, 1)
        upg.draw.set_transparent_color(0)
        upg.draw.text(15, 20, "PLAY PLAY PLAY", self.text_color)

        if self.frame_manager.total_time_ms // 1000 % 2 == 0:
            upg.draw.text(30, 50, "LET'S GO", self.text_color)
            
        if not self.is_enabled_key_input and self.frame_manager.total_frame > self.key_pressed_frame + MAX_FPS:
            self.my_game.request_change_scene(SCENE_GAME)

